use crate::api::ChatMessagePayload;
use crate::{RESET, GREEN, GRAY, BLUE};

pub trait HistoryObject {
    fn display_as_history(&self) -> String;
}

impl HistoryObject for ChatMessagePayload {
    fn display_as_history(&self) -> String {
        let user = &self.role;
        let msg = &self.content;

        let role_color = {
            if user == "user" { GREEN }
            else if user == "assistant" { BLUE }
            else { GRAY }
        };

        let short_user = {
            if user == "user" { "you" }
            else if user == "assistant" { "ai" }
            else { user }
        }.to_string();

        format!("{role_color}{short_user}{RESET}\t: {msg}{RESET}")
    }
}